Bug 1183193 - Review Request: ceres-solver - A non-linear least squares minimizer
Summary: Review Request: ceres-solver - A non-linear least squares minimizer
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
unspecified
medium
Target Milestone: ---
Assignee: Rich Mattes
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
: 1128662 (view as bug list)
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2015-01-17 00:39 UTC by Taylor Braun-Jones
Modified: 2015-05-26 21:31 UTC (History)
4 users (show)

Fixed In Version: ceres-solver-1.10.0-5.el7
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2015-04-21 18:37:30 UTC
richmattes: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)

Description Taylor Braun-Jones 2015-01-17 00:39:26 UTC
Spec URL: http://files.braun-jones.org/?download=public%2Fceres-solver.spec
SRPM URL: http://files.braun-jones.org/?download=public%2Fceres-solver-1.10.0-1.el7.centos.src.rpm
Description: 

Ceres Solver is an open source C++ library for modeling and solving
large, complicated optimization problems. It is a feature rich, mature
and performant library which has been used in production at Google
since 2010. Notable use of Ceres Solver is for the image alignment in
Google Maps and for vehicle pose in Google Street View. Ceres Solver
can solve two kinds of problems.

  1. Non-linear Least Squares problems with bounds constraints.
  2. General unconstrained optimization problems.

Features include:

  - A friendly API: build your objective function one term at a time
  - Automatic and numeric differentiation
  - Robust loss functions
  - Local parameterizations
  - Threaded Jacobian evaluators and linear solvers
  - Trust region solvers with non-monotonic steps (Levenberg-Marquardt and Dogleg (Powell & Subspace))
  - Line search solvers (L-BFGS and Nonlinear CG)
  - Dense QR and Cholesky factorization (using Eigen) for small problems
  - Sparse Cholesky factorization (using SuiteSparse) for large sparse problems
  - Specialized solvers for bundle adjustment problems in computer vision
  - Iterative linear solvers for general sparse and bundle adjustment problems
  - Runs on Linux, Windows, Mac OS X, Android, and iOS


Fedora Account System Username: nocnokneo

Comment 1 Christopher Meng 2015-01-17 11:17:30 UTC
I think I'd submitted this long time ago, although I didn't update it, see bug 1128662.

Comment 2 Antonio 2015-02-20 16:21:01 UTC
(In reply to Christopher Meng from comment #1)
> I think I'd submitted this long time ago, although I didn't update it, see
> bug 1128662.

Only one review please. Which one?

Comment 3 Taylor Braun-Jones 2015-02-20 17:58:04 UTC
Since both bugs have dead links it's hard to compare. Here are updated links for my spec and SRPM files:

http://files.braun-jones.org/ceres-solver.spec
http://files.braun-jones.org/ceres-solver-1.10.0-1.el7.centos.src.rpm

Since mine uses the latest 1.10 upstream release I was able to take advantage of a new build option that uses Eigen for the sparse matrix math and reduce the number of dependencies -- the only downside is that this means more restrictive licensing. See item 2 here for more info:

http://ceres-solver.org/version_history.html#id1

I don't have a strong opinion either way. Since this review is slightly more up-to-date, I say go with this one.

Comment 4 Christopher Meng 2015-02-21 10:49:23 UTC
I'm confused now. I asked you in comment 1 to see if you would let me finish this since I'm the first, and you never asked me in private before you submitted this.

Comment 5 Taylor Braun-Jones 2015-02-21 18:53:54 UTC
Hi Christopher, That sounds fine to me. You'll just need to fix the broken links to your spec and SRPM.

Antonio, once bug 1128662 is updated with with working spec and SRPM URLs, please close this bug and review the other one.

Comment 6 Christopher Meng 2015-02-22 00:55:11 UTC
Oh, you don't need to step aside this time because I don't have plenty of time, please continue. ;)

Next time please search bugzilla before submitting packages, because there are always lot of packages in the reviewing queue but nobody takes them. It's common...

Comment 7 Christopher Meng 2015-02-22 00:56:50 UTC
*** Bug 1128662 has been marked as a duplicate of this bug. ***

Comment 8 Taylor Braun-Jones 2015-02-26 02:35:03 UTC
Hi Christopher - You're right I messed up - sorry about that! I'll be sure to do a better job of searching through the bug tracker before submitting my next package request.

Now to find someone to review this package request...

Comment 9 Antonio 2015-02-26 11:02:03 UTC
(In reply to Taylor Braun-Jones from comment #8)
> 
> Now to find someone to review this package request...

http://fedoraproject.org/wiki/How_to_get_sponsored_into_the_packager_group
;)

Comment 10 Rich Mattes 2015-03-06 13:46:09 UTC
You have been sponsored as a result of 1177038, correct?  If so, please clear FE_NEEDSPONSOR.

I will handle the review for this package.

Comment 11 Rich Mattes 2015-03-07 01:39:57 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig called in %post and %postun if required.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
[x]: License file installed when any subpackage combination is installed.
[x]: Package requires other packages for directories it uses.
[!]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/share/ceres-solver
[!]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[!]: Each %files section contains %defattr if rpm < 4.4
     Note: %defattr present but not needed
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[!]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[!]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
[x]: Packages must not store files under /srv, /opt or /usr/local
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.

===== SHOULD items =====

Generic:
[!]: Buildroot is not present
     Note: Buildroot: present but not needed
[!]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
     Note: %clean present but not required
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[!]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in ceres-
     solver-devel
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[!]: Patches link to upstream bugs/comments/lists or are otherwise justified.
[-]: Scriptlets must be sane, if used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[!]: Package should compile and build into binary rpms on all supported
     architectures.
[!]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[!]: Spec use %global instead of %define unless justified.
     Note: %define requiring justification: %define optflags ""
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: SourceX is a working URL.

===== EXTRA items =====

Generic:
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: ceres-solver-1.10.0-1.fc21.x86_64.rpm
          ceres-solver-devel-1.10.0-1.fc21.x86_64.rpm
          ceres-solver-1.10.0-1.fc21.src.rpm
ceres-solver.x86_64: W: spelling-error Summary(en_US) minimizer -> minimize, minimizes, minimized
ceres-solver.x86_64: W: spelling-error %description -l en_US performant -> perform ant, perform-ant, performance
ceres-solver.x86_64: W: spelling-error %description -l en_US parameterizations -> characterizations, Americanizations, pasteurization
ceres-solver.x86_64: W: spelling-error %description -l en_US evaluators -> evaluates, evaporators, elevators
ceres-solver.x86_64: W: spelling-error %description -l en_US iOS -> OS, SOS, DOS
ceres-solver.x86_64: E: description-line-too-long C   - Trust region solvers with non-monotonic steps (Levenberg-Marquardt and Dogleg (Powell & Subspace))
ceres-solver-devel.x86_64: W: spelling-error Summary(en_US) minimizer -> minimize, minimizes, minimized
ceres-solver-devel.x86_64: W: only-non-binary-in-usr-lib
ceres-solver-devel.x86_64: W: no-documentation
ceres-solver.src: W: spelling-error Summary(en_US) minimizer -> minimize, minimizes, minimized
ceres-solver.src: W: spelling-error %description -l en_US performant -> perform ant, perform-ant, performance
ceres-solver.src: W: spelling-error %description -l en_US parameterizations -> characterizations, Americanizations, pasteurization
ceres-solver.src: W: spelling-error %description -l en_US evaluators -> evaluates, evaporators, elevators
ceres-solver.src: W: spelling-error %description -l en_US iOS -> OS, SOS, DOS
ceres-solver.src: E: description-line-too-long C   - Trust region solvers with non-monotonic steps (Levenberg-Marquardt and Dogleg (Powell & Subspace))
3 packages and 0 specfiles checked; 2 errors, 13 warnings.



Requires
--------
ceres-solver-devel (rpmlib, GLIBC filtered):
    ceres-solver

ceres-solver (rpmlib, GLIBC filtered):
    /sbin/ldconfig
    libc.so.6()(64bit)
    libgcc_s.so.1()(64bit)
    libgcc_s.so.1(GCC_3.0)(64bit)
    libgcc_s.so.1(GCC_4.0.0)(64bit)
    libglog.so.0()(64bit)
    libgomp.so.1()(64bit)
    libgomp.so.1(GOMP_1.0)(64bit)
    libgomp.so.1(GOMP_4.0)(64bit)
    libgomp.so.1(OMP_1.0)(64bit)
    libgomp.so.1(OMP_2.0)(64bit)
    libm.so.6()(64bit)
    libpthread.so.0()(64bit)
    libstdc++.so.6()(64bit)
    libstdc++.so.6(CXXABI_1.3)(64bit)
    rtld(GNU_HASH)



Provides
--------
ceres-solver-devel:
    ceres-solver-devel
    ceres-solver-devel(x86-64)

ceres-solver:
    ceres-solver
    ceres-solver(x86-64)
    libceres.so.1()(64bit)



Source checksums
----------------
http://ceres-solver.org/ceres-solver-1.10.0.tar.gz :
  CHECKSUM(SHA256) this package     : 20bb5db05c3e3e14a4062e2cf2b0742d2653359549ecded3e0653104ef3deb17
  CHECKSUM(SHA256) upstream package : 20bb5db05c3e3e14a4062e2cf2b0742d2653359549ecded3e0653104ef3deb17


Generated by fedora-review 0.5.2 (63c24cb) last change: 2014-07-14
Command line :/usr/bin/fedora-review -b 1183193
Buildroot used: fedora-21-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, EPEL5, BATCH, DISTTAG



=================================================

It's a good start, but there are some issues.

MUST:
- You should use the %license macro for LICENSE, instead of %doc (http://fedoraproject.org/wiki/Packaging:LicensingGuidelines)
- %{_datadir}/%{name} isn't owned by any packages - it should probably be owned by the -devel package
- The rpm optflags are completely removed, with a note that they "break the build". I rebuilt the package with the rpm optflags enabled on f21, and nothing broke.  The optflags should be restored, or more explaination on failures should be given. 
- The removal of the optflags also removes -g, which makes the -debuginfo package less useful
- Suitesparse only excludes tbb on s390 and s390x, you should follow suit and declare %ifnarch s390 s390x instead of using your current whitelist
- The package should BuildRequires: eigen3-static, instead of eigen3-devel (http://fedoraproject.org/wiki/Packaging:Guidelines#Packaging_Header_Only_Libraries)
- The description has a line that is too long - lines are limited to 80 characters or so

SHOULD:
- There are several constructs that are no longer needed for fedora: defattr in %files, the BuildRoot, and the %clean section.
- There are unit tests, but the spec does not have a %check section to run them
- The -devel package Requires for the base package should have the %_isa macro
- The patch has no explanation around it, even though its title is a little self explanatory.  Is there an upstream bug associated with it?

Comment 12 Taylor Braun-Jones 2015-03-11 14:11:25 UTC
Yes, you are right I no longer need sponsorship. FE_NEEDSPONSOR flag cleared.

Thanks for the review! New spec and SRPM available here:

http://files.braun-jones.org/ceres-solver.spec
http://files.braun-jones.org/ceres-solver-1.10.0-2.el7.centos.src.rpm

Comment 13 Rich Mattes 2015-03-12 01:44:48 UTC
It looks like you covered everything but the epel-specific constructs, which is fine if you're targeting centos as well as fedora (which it looks like you are)

Unfortunately, the tests are failing:
http://koji.fedoraproject.org/koji/taskinfo?taskID=9207143

It looks like it might have to do with the test that got re-enabled with the patch, and some CMake configuration issues.  It appears that CMake isn't picking up the suitesparse headers:

-- Failed to find CXSparse - Could not find CXSparse include directory, set CXSPARSE_INCLUDE_DIR to directory containing cs.h

You need to set -DCXSPARSE_INCLUDE_DIR=%{_includedir}/suitesparse in the call to cmake.

Once you do that, CMake reports that there's no BLAS implementation available, and that it needs one to build with suitesparse:
-- A library with BLAS API not found. Please specify library location.

The ATLAS library provides its BLAS routines in libsatlas.so, which CMake's FindBLAS apparently doesn't know to look for.  You have to set -DBLAS_LIBRARIES to the ATLAS blas lib: %{_libdir}/atlas/libsatlas.so

Once you do all that, CMake doesn't complain about missing deps, and the tests pass (in my local mockbuilds)

(ref: https://groups.google.com/forum/#!topic/ceres-solver/-9fdnMBtuKI)

Comment 14 Christopher Meng 2015-03-12 04:17:11 UTC
1. Drop rm -rf $RPM_BUILD_ROOT

2. Drop 

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

3. %{_datadir}/%{name}
%{_datadir}/%{name}/*.cmake

No, use this:

%dir %{_datadir}/%{name}
%{_datadir}/%{name}/*.cmake

(And these cmake files should be put under cmake module dir, but anyway I don't know who uses ceres now)

4. 
# Make the subdirectory in /usr/share match the name of this package
mv $RPM_BUILD_ROOT%{_datadir}/{Ceres,%{name}}

Well, is it accepted by upstream? Note that your change will only take effect on Fedora but not other distros at all.

Comment 15 Taylor Braun-Jones 2015-03-12 14:17:19 UTC
Thanks, Rich. I had played with the idea of using EIGENSPARSE=ON originally, but converted back to using SUITESPARSE=ON and forgot to add back the CXSPARSE_INCLUDE_DIR. I never had a problem finding BLAS, but adding the BLAS_LIBRARIES flag is a good idea anyway. While were on the topic, what is the preferred approach for the Fedora package?

  (1) Use SUITESPARSE for sparse metrix support. Increases the package
      dependencies but results in a ceres-solver package with a more
      permissive license (BSD)

  (2) Use EIGENSPARSE for sparse metrix support. Results in fewer package
      dependencies (because Eigen is already a hard dependency), but then
      ceres-solver becomes LGPL licensed.


Chris - Thanks for the review. 1, 2 fixed. 

3, 4 - For the cmake files, it would be helpful if the CMake packaging documentation[1] covered more details like this. I wasn't sure what was preferred in Fedora and was trying copy what I'd seen in some other Fedora packages. For now, I've just removed the mv line so that the .cmake files stay at the original upstream installation path %{_datadir}/Ceres.

New spec and SRPM here:

http://files.braun-jones.org/ceres-solver.spec
http://files.braun-jones.org/ceres-solver-1.10.0-3.el7.centos.src.rpm


[1] http://fedoraproject.org/wiki/Packaging:Cmake

Comment 16 Rich Mattes 2015-03-15 20:02:36 UTC
Have you been building in mock?  If you're building the package locally and happen to have a compatible BLAS package (e.g. OpenBLAS) installed, CMake will find and use that even if it's not what you intended..  The only way to be sure your dependencies and package configuration are correct is to build the package in mock (either locally or via koji scratch builds).

Personally, I'd probably lean towards (1) unless there's a good reason to use eigen instead (e.g. it's significantly faster.)  The suitesparse package isn't too big, and since the dependencies are taken care of by our package manager, there's no extra work to be done for consumers of the ceres-solver package.

CMake configuration script location isn't mandated by Fedora, but if you want CMake to find the scripts you need to put them somewhere on CMake's search path which is documented at http://www.cmake.org/cmake/help/v3.0/command/find_package.html.  In this case, CMake would have found the package either way: <name> is case-independent in the applicable "/usr/share/<name>*/" CMake search path.

One last thing: you might consider adding a BuildRequires on metis-devel to enable the optional METIS support.  metis is available in fedora and epel, I'm not sure what extra functionality it adds and whether it's worth it to include it.

That being said, the package as it stands looks good, and this package is APPROVED.

Comment 17 Taylor Braun-Jones 2015-03-16 19:03:22 UTC
(In reply to Rich Mattes from comment #16)
> Have you been building in mock?  If you're building the package locally and
> happen to have a compatible BLAS package (e.g. OpenBLAS) installed, CMake
> will find and use that even if it's not what you intended..  The only way to
> be sure your dependencies and package configuration are correct is to build
> the package in mock (either locally or via koji scratch builds).

Yes, I'm building in mock, but hadn't been carefully checking the CMake output from Ceres to see that it was being built without any sparse matrix support. I'll be more careful about that.

> Personally, I'd probably lean towards (1) unless there's a good reason to
> use eigen instead (e.g. it's significantly faster.)  The suitesparse package
> isn't too big, and since the dependencies are taken care of by our package
> manager, there's no extra work to be done for consumers of the ceres-solver
> package.

I agree, (1) seems to make the most sense to me as well. At least for now -- Eigen is a quickly improving library compared to SuiteSparse so it may be that it is significantly faster in the future.
 
> CMake configuration script location isn't mandated by Fedora, but if you
> want CMake to find the scripts you need to put them somewhere on CMake's
> search path which is documented at
> http://www.cmake.org/cmake/help/v3.0/command/find_package.html.  In this
> case, CMake would have found the package either way: <name> is
> case-independent in the applicable "/usr/share/<name>*/" CMake search path.

I guess that explains the lack of consistency I've seen with other CMake-based packages in Fedora. I guess I'll just stick with whatever upstream uses as long as it's one of those paths searched by find_package.

> One last thing: you might consider adding a BuildRequires on metis-devel to
> enable the optional METIS support.  metis is available in fedora and epel,
> I'm not sure what extra functionality it adds and whether it's worth it to
> include it.

Do you see ceres-solver using METIS directly somewhere? As far as I know, it just needs SuiteSparse for the sparse matrix support.
 
> That being said, the package as it stands looks good, and this package is
> APPROVED.

Thanks!

Rich/Christopher - Are either of you willing to be a co-maintainer? Or added to the InitialCC list? If so just me know your FAS username.

Comment 18 Rich Mattes 2015-03-16 19:07:33 UTC
(In reply to Taylor Braun-Jones from comment #17)
> Do you see ceres-solver using METIS directly somewhere? As far as I know, it
> just needs SuiteSparse for the sparse matrix support.

I saw a line in the CMake output about how it couldn't find METIS.  I didn't dig into what ceres uses METIS for though.
 
> Rich/Christopher - Are either of you willing to be a co-maintainer? Or added
> to the InitialCC list? If so just me know your FAS username.

I wouldn't mind if you added me (rmattes), so that I can rebuild the package when eigen3 updates come along (I'm one of the eigen3 package maintainers).

Comment 19 Taylor Braun-Jones 2015-03-16 21:07:45 UTC
New Package SCM Request
=======================
Package Name: ceres-solver
Short Description: A non-linear least squares minimizer
Upstream URL: http://ceres-solver.org/
Owners: nocnokneo rmattes
Branches: f20 f21 f22 el6 epel7
InitialCC:

Comment 20 Gwyn Ciesla 2015-03-17 12:56:51 UTC
Git done (by process-git-requests).

Comment 21 Rich Mattes 2015-03-31 19:12:55 UTC
Any updates on builds here?  It looks like one build failed on rawhide due to the incomplete C++11 ABI transition.  That shouldn't affect f22 and below though.

Comment 22 Taylor Braun-Jones 2015-03-31 20:39:42 UTC
I haven't been able to make progress due to http protocol git access that broke recently:

https://fedorahosted.org/fedora-infrastructure/ticket/4688

Comment 23 Fedora Update System 2015-04-04 14:51:11 UTC
ceres-solver-1.10.0-3.fc22 has been submitted as an update for Fedora 22.
https://admin.fedoraproject.org/updates/ceres-solver-1.10.0-3.fc22

Comment 24 Fedora Update System 2015-04-05 17:54:32 UTC
ceres-solver-1.10.0-3.fc22 has been pushed to the Fedora 22 testing repository.

Comment 25 Fedora Update System 2015-04-21 18:37:30 UTC
ceres-solver-1.10.0-3.fc22 has been pushed to the Fedora 22 stable repository.

Comment 26 Fedora Update System 2015-05-10 01:48:02 UTC
ceres-solver-1.10.0-5.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/ceres-solver-1.10.0-5.el6

Comment 27 Fedora Update System 2015-05-10 01:49:04 UTC
ceres-solver-1.10.0-5.el7 has been submitted as an update for Fedora EPEL 7.
https://admin.fedoraproject.org/updates/ceres-solver-1.10.0-5.el7

Comment 28 Fedora Update System 2015-05-26 21:24:03 UTC
ceres-solver-1.10.0-5.el6 has been pushed to the Fedora EPEL 6 stable repository.

Comment 29 Fedora Update System 2015-05-26 21:31:57 UTC
ceres-solver-1.10.0-5.el7 has been pushed to the Fedora EPEL 7 stable repository.


Note You need to log in before you can comment on or make changes to this bug.